Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 2528)
@@ -4,6 +4,7 @@
    !! Ocean diagnostics:  ocean tracers and dynamic trends
    !!=====================================================================
-   !! History :  9.0  !  04-08  (C. Talandier) Original code
-   !!                 !  05-04  (C. Deltel)    Add Asselin trend in the ML budget
+   !! History :  1.0  !  2004-08  (C. Talandier) Original code
+   !!             -   !  2005-04  (C. Deltel)    Add Asselin trend in the ML budget
+   !!            3.3  ! 2010-10  (C. Ethe, G. Madec) reorganisation of initialisation phase
    !!----------------------------------------------------------------------
 #if  defined key_trdtra || defined key_trddyn || defined key_trdmld || defined key_trdvor || defined key_esopa
@@ -36,12 +37,12 @@
 #  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
-   !!   OPA 9.0 , LOCEAN-IPSL (2005) 
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
    !! $Id$
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
 
 CONTAINS
 
-   SUBROUTINE trd_mod( ptrdx, ptrdy, ktrd, ctype, kt, cnbpas )
+   SUBROUTINE trd_mod( ptrdx, ptrdy, ktrd, ctype, kt )
       !!---------------------------------------------------------------------
       !!                  ***  ROUTINE trd_mod  ***
@@ -53,10 +54,8 @@
       INTEGER, INTENT( in ) ::   ktrd                              ! tracer trend index
       CHARACTER(len=3), INTENT( in ) ::   ctype                    ! momentum or tracers trends type 'DYN'/'TRA'
-      CHARACTER(len=3), INTENT( in ), OPTIONAL ::   cnbpas         ! number of passage
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   ptrdx ! Temperature or U trend 
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   ptrdy ! Salinity    or V trend
       !!
       INTEGER ::   ji, jj
-      CHARACTER(len=3) ::   ccpas                                  ! number of passage
       REAL(wp), DIMENSION(jpi,jpj) ::   ztswu, ztswv               ! 2D workspace
       REAL(wp), DIMENSION(jpi,jpj) ::   ztbfu, ztbfv               ! 2D workspace
@@ -65,8 +64,4 @@
 
       z2dx(:,:)   = 0.e0   ;   z2dy(:,:)   = 0.e0                  ! initialization of workspace arrays
-
-      ! Control of optional arguments
-      ccpas = 'fst'
-      IF( PRESENT(cnbpas) )  ccpas = cnbpas
 
       IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (restarting with Euler time stepping)
@@ -95,5 +90,5 @@
             CASE ( jptra_trd_yad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_yad, ctype )   ! y- horiz adv
             CASE ( jptra_trd_zad )                                                         ! z- vertical adv 
-               CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype, clpas=ccpas )   
+               CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype )   
                ! compute the surface flux condition wn(:,:,1)*tn(:,:,1)
                z2dx(:,:) = wn(:,:,1)*tn(:,:,1)/fse3t(:,:,1)
@@ -222,8 +217,8 @@
 
       ENDIF
-
+      !
    END SUBROUTINE trd_mod
 
-#   else
+#else
    !!----------------------------------------------------------------------
    !!   Default case :                                         Empty module
@@ -235,20 +230,12 @@
 
 CONTAINS
-   SUBROUTINE trd_mod(ptrd3dx, ptrd3dy, ktrd , ctype, kt, cnbpas)   ! Empty routine
-      REAL, DIMENSION(:,:,:), INTENT( in ) ::   &
-          ptrd3dx,                     &                           ! Temperature or U trend 
-          ptrd3dy                                                  ! Salinity    or V trend
-      INTEGER, INTENT( in ) ::   ktrd                              ! momentum or tracer trend index
-      INTEGER, INTENT( in ) ::   kt                                ! Time step
-      CHARACTER(len=3), INTENT( in ) ::  ctype                     ! momentum or tracers trends type
-      CHARACTER(len=3), INTENT( in ), OPTIONAL ::   cnbpas         ! number of passage
-      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', ptrd3dx(1,1,1)
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ptrd3dy(1,1,1)
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ktrd
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ctype
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', kt
-      WRITE(*,*) ' "   ": You should not have seen this print! error ?', cnbpas
+   SUBROUTINE trd_mod(ptrd3dx, ptrd3dy, ktrd , ctype, kt )   ! Empty routine
+      REAL    ::   ptrd3dx(:,:,:), ptrd3dy(:,:,:)
+      INTEGER ::   ktrd, kt                            
+      CHARACTER(len=3) ::  ctype                  
+      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', ptrd3dx(1,1,1), ptrd3dy(1,1,1)
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ktrd, ctype, kt
    END SUBROUTINE trd_mod
-#   endif
+#endif
 
    SUBROUTINE trd_mod_init
@@ -259,5 +246,5 @@
       !!----------------------------------------------------------------------
       USE in_out_manager          ! I/O manager
-
+      !!    
       NAMELIST/namtrd/ nn_trd, nn_ctls, cn_trdrst_in, cn_trdrst_out, ln_trdmld_restart, rn_ucf, ln_trdmld_instant
       !!----------------------------------------------------------------------
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod_oce.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod_oce.F90	(revision 2527)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod_oce.F90	(revision 2528)
@@ -4,5 +4,5 @@
    !! Ocean trends :   set tracer and momentum trend variables
    !!======================================================================
-   !! History :  9.0  !  04-08  (C. Talandier) Original code
+   !! History :  1.0  !  2004-08  (C. Talandier) Original code
    !!----------------------------------------------------------------------
    USE trdicp_oce              ! ocean momentum/tracers bassin properties trends variables
@@ -24,46 +24,56 @@
 
 # if defined key_trdtra   ||   defined key_trdmld
-   LOGICAL , PUBLIC ::   l_trdtra = .TRUE.              !: tracers  trend flag
+   LOGICAL , PUBLIC ::   l_trdtra = .TRUE.                !: tracers  trend flag
 # else
-   LOGICAL , PUBLIC ::   l_trdtra = .FALSE.             !: tracers  trend flag
+   LOGICAL , PUBLIC ::   l_trdtra = .FALSE.               !: tracers  trend flag
 # endif
 # if defined key_trddyn   ||   defined key_trdvor
-   LOGICAL , PUBLIC ::   l_trddyn = .TRUE.              !: momentum trend flag
+   LOGICAL , PUBLIC ::   l_trddyn = .TRUE.                !: momentum trend flag
 # else
-   LOGICAL , PUBLIC ::   l_trddyn = .FALSE.             !: momentum trend flag
+   LOGICAL , PUBLIC ::   l_trddyn = .FALSE.               !: momentum trend flag
 # endif
-
-   !                                                   !!! Active tracers trends indexes
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_xad =  1   !: x- horizontal advection
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_yad =  2   !: y- horizontal advection
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zad =  3   !: z- vertical   advection
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_ldf =  4   !: lateral       diffusion
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zdf =  5   !: vertical diffusion (Kz)
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbc =  6   !: Bottom Boundary Condition (geoth. flux) 
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbl =  7   !: Bottom Boundary Layer (diffusive/convective)
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_npc =  8   !: static instability mixing
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_dmp =  9   !: damping
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_qsr = 10   !: penetrative solar radiation
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_nsr = 11   !: non solar radiation
-   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_atf = 12   !: Asselin correction
+# if ( defined key_trdtrc && defined key_iomput )  ||  defined key_trdmld_trc
+   LOGICAL , PUBLIC ::   l_trdtrc = .TRUE.                !: tracers  trend flag
+# else
+   LOGICAL , PUBLIC ::   l_trdtrc = .FALSE.               !: tracers  trend flag
+# endif
+   !                                                     !!!* Active tracers trends indexes
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_xad =  1     !: x- horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_yad =  2     !: y- horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zad =  3     !: z- vertical   advection
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_ldf =  4     !: lateral       diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zdf =  5     !: vertical diffusion (Kz)
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbc =  6     !: Bottom Boundary Condition (geoth. flux) 
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbl =  7     !: Bottom Boundary Layer (diffusive/convective)
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_npc =  8     !: static instability mixing
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_dmp =  9     !: damping
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_qsr = 10     !: penetrative solar radiation
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_nsr = 11     !: non solar radiation
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_atf = 12     !: Asselin correction
+#if defined key_top
+   !                                                     !!!* Passive tracers trends indexes
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_sms  = 13    !: sources m. sinks
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_radn = 14    !: corr. trn<0 in trcrad
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_radb = 15    !: corr. trb<0 in trcrad (like atf)
+#endif
    
-   !                                                   !!! Momentum trends indexes
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_hpg =  1   !: hydrostatic pressure gradient 
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_keg =  2   !: kinetic energy gradient
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_rvo =  3   !: relative vorticity
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_pvo =  4   !: planetary vorticity
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_ldf =  5   !: lateral diffusion
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_had =  6   !: horizontal advection
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_zad =  7   !: vertical advection
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_zdf =  8   !: vertical diffusion
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_spg =  9   !: surface pressure gradient
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_dat = 10   !: damping term
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_swf = 11   !: surface wind forcing
-   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_bfr = 12   !: bottom friction 
+   !                                                     !!!* Momentum trends indexes
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_hpg =  1     !: hydrostatic pressure gradient 
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_keg =  2     !: kinetic energy gradient
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_rvo =  3     !: relative vorticity
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_pvo =  4     !: planetary vorticity
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_ldf =  5     !: lateral diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_had =  6     !: horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_zad =  7     !: vertical advection
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_zdf =  8     !: vertical diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_spg =  9     !: surface pressure gradient
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_dat = 10     !: damping term
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_swf = 11     !: surface wind forcing
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_bfr = 12     !: bottom friction 
 
    !!----------------------------------------------------------------------
-   !! NEMO/OPA 3.2 , LOCEAN-IPSL (2009) 
-   !! $Id$ 
-   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
    !!======================================================================
 END MODULE trdmod_oce
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod_trc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod_trc.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdmod_trc.F90	(revision 2528)
@@ -0,0 +1,24 @@
+MODULE trdmod_trc
+   !!======================================================================
+   !!                       ***  MODULE trdmod_trc  ***
+   !!  Dummy module
+   !!======================================================================
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+   !!----------------------------------------------------------------------
+   !!   Dummy module                                             NO TOP use
+   !!----------------------------------------------------------------------
+CONTAINS
+
+   SUBROUTINE trd_mod_trc( ptrtrd, kjn, ktrd, kt )
+      INTEGER ::   kt, kjn, ktrd   
+      REAL    ::   ptrtrd(:,:,:)  
+      WRITE(*,*) 'trd_mod_trc_trp : You should not have seen this print! error?', ptrtrd(1,1,1)
+      WRITE(*,*) '  "      "      : You should not have seen this print! error?', kjn, ktrd, kt
+   END SUBROUTINE trd_mod_trc
+
+   !!======================================================================
+END MODULE trdmod_trc
Index: trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdtra.F90
===================================================================
--- trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdtra.F90	(revision 2528)
+++ trunk/NEMOGCM/NEMO/OPA_SRC/TRD/trdtra.F90	(revision 2528)
@@ -0,0 +1,194 @@
+MODULE trdtra
+   !!======================================================================
+   !!                       ***  MODULE  trdtra  ***
+   !! Ocean diagnostics:  ocean tracers trends
+   !!=====================================================================
+   !! History :  9.0  !  2004-08  (C. Talandier) Original code
+   !!                 !  2005-04  (C. Deltel)    Add Asselin trend in the ML budget
+   !!      NEMO  3.3  !  2010-06  (C. Ethe) merge TRA-TRC 
+   !!----------------------------------------------------------------------
+#if  defined key_trdtra || defined key_trdmld || defined key_trdmld_trc 
+   !!----------------------------------------------------------------------
+   !!   trd_tra      : Call the trend to be computed
+   !!----------------------------------------------------------------------
+   USE dom_oce            ! ocean domain 
+   USE trdmod_oce         ! ocean active mixed layer tracers trends 
+   USE trdmod             ! ocean active mixed layer tracers trends 
+   USE trdmod_trc         ! ocean passive mixed layer tracers trends 
+
+   IMPLICIT NONE
+   PRIVATE
+
+   PUBLIC trd_tra          ! called by all  traXX modules
+ 
+   !! * Module declaration
+   REAL(wp), DIMENSION(jpi,jpj,jpk), SAVE :: trdtx, trdty, trdt  !:
+
+   !! * Substitutions
+#  include "domzgr_substitute.h90"
+#  include "vectopt_loop_substitute.h90"
+   !!----------------------------------------------------------------------
+   !! NEMO/OPA 3.3 , NEMO Consortium (2010)
+   !! $Id$
+   !! Software governed by the CeCILL licence (NEMOGCM/NEMO_CeCILL.txt)
+   !!----------------------------------------------------------------------
+
+CONTAINS
+
+   SUBROUTINE trd_tra( kt, ctype, ktra, ktrd, ptrd, pun, ptra )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_tra  ***
+      !! 
+      !! ** Purpose : Dispatch all trends computation, e.g. vorticity, mld or 
+      !!              integral constraints
+      !!
+      !! ** Method/usage : For the mixed-layer trend, the control surface can be either
+      !!       a mixed layer depth (time varying) or a fixed surface (jk level or bowl). 
+      !!      Choose control surface with nn_ctls in namelist NAMTRD :
+      !!        nn_ctls = 0  : use mixed layer with density criterion 
+      !!        nn_ctls = 1  : read index from file 'ctlsurf_idx'
+      !!        nn_ctls > 1  : use fixed level surface jk = nn_ctls
+      !!----------------------------------------------------------------------
+      INTEGER                         , INTENT(in)           ::  kt      ! time step
+      CHARACTER(len=3)                , INTENT(in)           ::  ctype   ! tracers trends type 'TRA'/'TRC'
+      INTEGER                         , INTENT(in)           ::  ktra    ! tracer index
+      INTEGER                         , INTENT(in)           ::  ktrd    ! tracer trend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)           ::  ptrd    ! tracer trend  or flux
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL ::  pun     ! velocity 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL ::  ptra    ! Tracer variable 
+      !!
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::  ztrds    !  
+      !!----------------------------------------------------------------------
+
+      ! Control of optional arguments
+      IF( ctype == 'TRA' .AND. ktra == jp_tem ) THEN 
+         IF( PRESENT( ptra ) ) THEN    
+            SELECT CASE( ktrd )            ! shift depending on the direction
+            CASE( jptra_trd_xad )  ;  CALL trd_tra_adv( ptrd, pun, ptra, 'X', trdtx ) 
+            CASE( jptra_trd_yad )  ;  CALL trd_tra_adv( ptrd, pun, ptra, 'Y', trdty ) 
+            CASE( jptra_trd_zad )  ;  CALL trd_tra_adv( ptrd, pun, ptra, 'Z', trdt  ) 
+            END SELECT
+         ELSE
+            trdt(:,:,:) = ptrd(:,:,:)
+            IF( ktrd == jptra_trd_bbc .OR. ktrd == jptra_trd_qsr ) THEN
+               ztrds(:,:,:) = 0.
+               CALL trd_mod( trdt, ztrds, ktrd, ctype, kt )
+            END IF
+         END IF
+      END IF
+
+      IF( ctype == 'TRA' .AND. ktra == jp_sal ) THEN 
+         IF( PRESENT( ptra ) ) THEN    
+            SELECT CASE( ktrd )            ! shift depending on the direction
+            CASE( jptra_trd_xad )  
+                                CALL trd_tra_adv( ptrd, pun, ptra, 'X', ztrds ) 
+                                CALL trd_mod( trdtx, ztrds, ktrd, ctype, kt   )
+            CASE( jptra_trd_yad )  
+                                CALL trd_tra_adv( ptrd, pun, ptra, 'Y', ztrds ) 
+                                CALL trd_mod( trdty, ztrds, ktrd, ctype, kt   )
+            CASE( jptra_trd_zad )    
+                                CALL trd_tra_adv( ptrd, pun, ptra, 'Z', ztrds ) 
+                                CALL trd_mod( trdt , ztrds, ktrd, ctype, kt   )
+            END SELECT
+         ELSE
+            ztrds(:,:,:) = ptrd(:,:,:)
+            CALL trd_mod( trdt, ztrds, ktrd, ctype, kt )  
+         END IF
+      END IF
+
+      IF( ctype == 'TRC' ) THEN
+         !
+         IF( PRESENT( ptra ) ) THEN  
+            SELECT CASE( ktrd )            ! shift depending on the direction
+            CASE( jptra_trd_xad )  
+                                CALL trd_tra_adv( ptrd, pun, ptra, 'X', ztrds ) 
+                                CALL trd_mod_trc( ztrds, ktra, ktrd, kt       )
+            CASE( jptra_trd_yad )  
+                                CALL trd_tra_adv( ptrd, pun, ptra, 'Y', ztrds ) 
+                                CALL trd_mod_trc( ztrds, ktra, ktrd, kt       )
+            CASE( jptra_trd_zad )    
+                                CALL trd_tra_adv( ptrd, pun, ptra, 'Z', ztrds ) 
+                                CALL trd_mod_trc( ztrds, ktra, ktrd, kt       )
+            END SELECT
+         ELSE
+            ztrds(:,:,:) = ptrd(:,:,:)
+            CALL trd_mod_trc( ztrds, ktra, ktrd, kt       )  
+         END IF
+         !
+      ENDIF
+      !
+   END SUBROUTINE trd_tra
+
+   SUBROUTINE trd_tra_adv( pf, pun, ptn, cdir, ptrd )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_tra_adv  ***
+      !! 
+      !! ** Purpose :   transformed the i-, j- or k-advective flux into thes
+      !!              i-, j- or k-advective trends, resp.
+      !! ** Method  :   i-advective trends = -un. di-1[T] = -( di-1[fi] - tn di-1[un] )
+      !!                k-advective trends = -un. di-1[T] = -( dj-1[fi] - tn dj-1[un] )
+      !!                k-advective trends = -un. di+1[T] = -( dk+1[fi] - tn dk+1[un] )
+      !!----------------------------------------------------------------------
+      REAL(wp)        , INTENT(in ), DIMENSION(jpi,jpj,jpk)           ::   pf      ! advective flux in one direction
+      REAL(wp)        , INTENT(in ), DIMENSION(jpi,jpj,jpk)           ::   pun     ! now velocity  in one direction
+      REAL(wp)        , INTENT(in ), DIMENSION(jpi,jpj,jpk)           ::   ptn     ! now or before tracer 
+      CHARACTER(len=1), INTENT(in )                                   ::   cdir    ! X/Y/Z direction
+      REAL(wp)        , INTENT(out), DIMENSION(jpi,jpj,jpk)           ::   ptrd    ! advective trend in one direction
+      !!
+      INTEGER                          ::   ji, jj, jk   ! dummy loop indices
+      INTEGER                          ::   ii, ij, ik   ! index shift function of the direction
+      REAL(wp)                         ::   zbtr         ! temporary scalar
+      !!----------------------------------------------------------------------
+
+      SELECT CASE( cdir )            ! shift depending on the direction
+      CASE( 'X' )   ;   ii = 1   ; ij = 0   ;   ik = 0      ! i-advective trend
+      CASE( 'Y' )   ;   ii = 0   ; ij = 1   ;   ik = 0      ! j-advective trend
+      CASE( 'Z' )   ;   ii = 0   ; ij = 0   ;   ik =-1      ! k-advective trend
+      END SELECT
+
+      !                              ! set to zero uncomputed values
+      ptrd(jpi,:,:) = 0.e0   ;   ptrd(1,:,:) = 0.e0
+      ptrd(:,jpj,:) = 0.e0   ;   ptrd(:,1,:) = 0.e0
+      ptrd(:,:,jpk) = 0.e0
+      !
+      !
+      DO jk = 1, jpkm1
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1   ! vector opt.
+               zbtr    = 1.e0/ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+               ptrd(ji,jj,jk) = - zbtr * (      pf (ji,jj,jk) - pf (ji-ii,jj-ij,jk-ik)                    &
+                 &                          - ( pun(ji,jj,jk) - pun(ji-ii,jj-ij,jk-ik) ) * ptn(ji,jj,jk)  )
+            END DO
+         END DO
+      END DO
+      !
+   END SUBROUTINE trd_tra_adv
+
+#   else
+   !!----------------------------------------------------------------------
+   !!   Default case :                                         Empty module
+   !!----------------------------------------------------------------------
+   USE par_oce      ! ocean variables trends
+
+CONTAINS
+
+   SUBROUTINE trd_tra( kt, ctype, ktra, ktrd, ptrd, pu, ptra )
+      !!----------------------------------------------------------------------
+      INTEGER                         , INTENT(in)           ::  kt      ! time step
+      CHARACTER(len=3)                , INTENT(in)           ::  ctype   ! tracers trends type 'TRA'/'TRC'
+      INTEGER                         , INTENT(in)           ::  ktra    ! tracer index
+      INTEGER                         , INTENT(in)           ::  ktrd    ! tracer trend index
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in)           ::  ptrd    ! tracer trend 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL ::  pu      ! velocity 
+      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT(in), OPTIONAL ::  ptra    ! Tracer variable 
+      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', ptrd(1,1,1)
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ptra(1,1,1)
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', pu(1,1,1)
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ktrd
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ktra
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', ctype
+      WRITE(*,*) ' "   ": You should not have seen this print! error ?', kt
+   END SUBROUTINE trd_tra
+#   endif
+   !!======================================================================
+END MODULE trdtra
